Index: httpd-2.4.23/modules/proxy/mod_proxy.c
===================================================================
--- httpd-2.4.23.orig/modules/proxy/mod_proxy.c	2022-01-05 11:32:35.567891132 +0100
+++ httpd-2.4.23/modules/proxy/mod_proxy.c	2022-01-05 11:32:35.571891155 +0100
@@ -555,9 +555,10 @@ static int proxy_detect(request_rec *r)
 
     /* Ick... msvc (perhaps others) promotes ternary short results to int */
 
-    if (conf->req && r->parsed_uri.scheme && r->parsed_uri.hostname) {
+    if (conf->req && r->parsed_uri.scheme) {
         /* but it might be something vhosted */
-        if (ap_cstr_casecmp(r->parsed_uri.scheme, ap_http_scheme(r)) != 0
+        if (!r->parsed_uri.hostname
+            || ap_cstr_casecmp(r->parsed_uri.scheme, ap_http_scheme(r)) != 0
             || !ap_matches_request_vhost(r, r->parsed_uri.hostname,
                                          (apr_port_t)(r->parsed_uri.port_str
                                                       ? r->parsed_uri.port
Index: httpd-2.4.23/modules/proxy/mod_proxy.h
===================================================================
--- httpd-2.4.23.orig/modules/proxy/mod_proxy.h	2022-01-05 11:32:35.559891087 +0100
+++ httpd-2.4.23/modules/proxy/mod_proxy.h	2022-01-05 11:32:35.575891177 +0100
@@ -677,6 +677,7 @@ PROXY_DECLARE(char *) ap_proxy_worker_na
 #define AP_PROXY_WORKER_IS_PREFIX   (1u << 0)
 #define AP_PROXY_WORKER_IS_MATCH    (1u << 1)
 #define AP_PROXY_WORKER_IS_MALLOCED (1u << 2)
+#define AP_PROXY_WORKER_NO_UDS      (1u << 3)
 
 /**
  * Get the worker from proxy configuration, looking for either PREFIXED or
Index: httpd-2.4.23/modules/proxy/proxy_util.c
===================================================================
--- httpd-2.4.23.orig/modules/proxy/proxy_util.c	2022-01-05 11:32:35.567891132 +0100
+++ httpd-2.4.23/modules/proxy/proxy_util.c	2022-01-05 11:32:35.575891177 +0100
@@ -1524,9 +1524,11 @@ PROXY_DECLARE(proxy_worker *) ap_proxy_g
         return NULL;
     }
 
-    url = ap_proxy_de_socketfy(p, url);
-    if (!url) {
-        return NULL;
+    if (!(mask & AP_PROXY_WORKER_NO_UDS)) {
+        url = ap_proxy_de_socketfy(p, url);
+        if (!url) {
+            return NULL;
+        }
     }
 
     c = ap_strchr_c(url, ':');
@@ -2053,22 +2055,22 @@ PROXY_DECLARE(int) ap_proxy_pre_request(
 
     access_status = proxy_run_pre_request(worker, balancer, r, conf, url);
     if (access_status == DECLINED && *balancer == NULL) {
-        *worker = ap_proxy_get_worker(r->pool, NULL, conf, *url);
+        const int forward = (r->proxyreq == PROXYREQ_PROXY);
+        *worker = ap_proxy_get_worker_ex(r->pool, NULL, conf, *url,
+                                         forward ? AP_PROXY_WORKER_NO_UDS : 0);
         if (*worker) {
             ap_log_rerror(APLOG_MARK, APLOG_TRACE2, 0, r,
                           "%s: found worker %s for %s",
                           (*worker)->s->scheme, (*worker)->s->name, *url);
-            *balancer = NULL;
-            if (!fix_uds_filename(r, url)) {
+            if (!forward && !fix_uds_filename(r, url)) {
                 return HTTP_INTERNAL_SERVER_ERROR;
             }
             access_status = OK;
         }
-        else if (r->proxyreq == PROXYREQ_PROXY) {
+        else if (forward) {
             if (conf->forward) {
                 ap_log_rerror(APLOG_MARK, APLOG_TRACE2, 0, r,
                               "*: found forward proxy worker for %s", *url);
-                *balancer = NULL;
                 *worker = conf->forward;
                 access_status = OK;
                 /*
@@ -2082,8 +2084,8 @@ PROXY_DECLARE(int) ap_proxy_pre_request(
         else if (r->proxyreq == PROXYREQ_REVERSE) {
             if (conf->reverse) {
                 ap_log_rerror(APLOG_MARK, APLOG_TRACE2, 0, r,
-                              "*: using default reverse proxy worker for %s (no keepalive)", *url);
-                *balancer = NULL;
+                              "*: using default reverse proxy worker for %s "
+                              "(no keepalive)", *url);
                 *worker = conf->reverse;
                 access_status = OK;
                 /*